> ## Documentation Index
> Fetch the complete documentation index at: https://docs.skillable.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Retrieve multiple lab instance details or results

> The lab instance **Search** command returns paginated information about either lab instance details or lab instance results for all lab instances that meet selected criteria. 
The response body will contain a collection of instance results in one of two formats, depending on the mode specified:

- Mode = 0, standard: a collection of responses in the format of the **[Result](https://docs.skillable.com/apidocs/retrieve-information-about-a-lab-instance-result-1)** command
- Mode = 5, concise: a collection of responses containing portions of the **[Details](https://docs.skillable.com/apidocs/retrieve-details-about-a-lab-instance)** and **[Result](https://docs.skillable.com/apidocs/retrieve-information-about-a-lab-instance-result-1)** commands.
- Mode = 10, verbose (default): a collection of responses in the format of the **[Details](https://docs.skillable.com/apidocs/retrieve-details-about-a-lab-instance)** command 



## OpenAPI

````json GET /labinstance/search
{
  "openapi": "3.0.3",
  "info": {
    "title": "Lab API",
    "description": "# Introduction \nWelcome to Skillable Connect: LAB Edition, our core platform for creating, customizing, and managing labs. \n\n## Skillable Production API & Integration Testing\nOnly lab profiles with a development status of **Complete** are consumable via API.\n\nDevelopment/Integration Testing API available with all the same API calls your production API can make, but has the following settings:\n\n- Max Active Lab Instances: 5\n- Max Saved Labs per User: 1\n- Max Active Lab Instances per user: 5\n- Max lab duration: 30 minutes\n- Allows launching of lab profiles with any Development Status (i.e. is not restricted to a Complete development status)\n- Has a dedicated API key\n- Does not generate billable events\n\n## Authenticate with API Key\nSkillable APIs offer one form of authentication: an API Key. All methods require an API Key, which must be obtained from a Skillable team member working with your organization. Our systems use this key to validate your development account. \n\nPass your API Key as an HTTP request header with the header name \"api_key\".\n\n\n<SecurityDefinitions />\n",
    "termsOfService": "https://skillable.com/terms-and-conditions/",
    "contact": {
      "name": "Skillable Support",
      "email": "support@skillable.com",
      "url": "https://skillable.com/customer-support/"
    },
    "x-logo": {
      "url": "https://raw.githubusercontent.com/LearnOnDemandSystems/ConnectAPI/main/Skillable%20Connect%20Logo.svg",
      "altText": "Skillable Connect"
    },
    "license": {
      "name": "Apache 2.0",
      "url": "http://www.apache.org/licenses/LICENSE-2.0.html"
    },
    "version": "3.0"
  },
  "servers": [
    {
      "url": "https://labondemand.com/api/v3",
      "description": "Skillable Connect LAB API"
    }
  ],
  "paths": {
    "/labinstance/search": {
      "parameters": [],
      "get": {
        "summary": "Retrieve multiple lab instance details or results",
        "tags": [
          "Lab Instance Management"
        ],
        "responses": {
          "200": {
            "description": "OK Response.",
            "content": {
              "application/json": {
                "schema": {
                  "type": "object",
                  "properties": {
                    "TotalResults": {
                      "type": "integer",
                      "x-stoplight": {
                        "id": "h5s48n18h1ca4"
                      },
                      "example": "878",
                      "description": "The total number of results found."
                    },
                    "TotalPages": {
                      "type": "integer",
                      "x-stoplight": {
                        "id": "vpzujejh05rgu"
                      },
                      "example": "9",
                      "description": "The total number of pages containing results."
                    },
                    "Results": {
                      "x-stoplight": {
                        "id": "xo2qmubw7w1un"
                      },
                      "oneOf": [
                        {
                          "$ref": "#/components/schemas/ResultResponse"
                        },
                        {
                          "$ref": "#/components/schemas/DetailsResponse"
                        },
                        {
                          "$ref": "#/components/schemas/ConciseResponse"
                        }
                      ],
                      "description": "Response format depends on mode specified. 0 for standard /Result, 5 for concise, 10 for verbose). "
                    }
                  }
                }
              }
            }
          }
        },
        "operationId": "LabInstanceSearch",
        "x-stoplight": {
          "id": "1i3hzl72od78k"
        },
        "description": "The lab instance **Search** command returns paginated information about either lab instance details or lab instance results for all lab instances that meet selected criteria. \r\nThe response body will contain a collection of instance results in one of two formats, depending on the mode specified:\r\n\r\n- Mode = 0, standard: a collection of responses in the format of the **[Result](https://docs.skillable.com/apidocs/retrieve-information-about-a-lab-instance-result-1)** command\r\n- Mode = 5, concise: a collection of responses containing portions of the **[Details](https://docs.skillable.com/apidocs/retrieve-details-about-a-lab-instance)** and **[Result](https://docs.skillable.com/apidocs/retrieve-information-about-a-lab-instance-result-1)** commands.\r\n- Mode = 10, verbose (default): a collection of responses in the format of the **[Details](https://docs.skillable.com/apidocs/retrieve-details-about-a-lab-instance)** command \r\n\r\n",
        "parameters": [
          {
            "schema": {
              "type": "integer",
              "format": "int64",
              "example": "1717516139"
            },
            "in": "query",
            "name": "start",
            "description": "The earliest start time of lab instances to return (in Unix epoch time)."
          },
          {
            "schema": {
              "type": "integer",
              "format": "int64",
              "example": "1712245739"
            },
            "in": "query",
            "name": "end",
            "description": "The latest end time of lab instances to return  (in Unix epoch time)."
          },
          {
            "schema": {
              "type": "string"
            },
            "in": "query",
            "name": "userId",
            "description": "The user id of the external system. Must be an exact match. "
          },
          {
            "schema": {
              "type": "integer",
              "format": "int32",
              "example": "54321"
            },
            "in": "query",
            "name": "labSeriesId",
            "description": "The unique numeric identifier of the series the lab profile belongs to."
          },
          {
            "schema": {
              "type": "integer",
              "format": "int32",
              "example": "12345"
            },
            "in": "query",
            "name": "labProfileId",
            "description": "The unique numeric identifier of the lab profile."
          },
          {
            "schema": {
              "type": "integer",
              "default": "0",
              "format": "int32"
            },
            "in": "query",
            "name": "pageIndex",
            "description": "The index of the paged result to return."
          },
          {
            "schema": {
              "type": "integer",
              "default": "100",
              "format": "int32"
            },
            "in": "query",
            "name": "pageSize",
            "description": "The size of the paged result to return."
          },
          {
            "schema": {
              "type": "string",
              "default": "start desc"
            },
            "in": "query",
            "name": "sort",
            "description": "The desired sort order of the results. Options include: start (default), start desc, end, end desc, userid, userid desc, labseriesid, labseriesid desc, labprofileid, labprofileid desc."
          },
          {
            "schema": {
              "type": "integer",
              "default": "10",
              "format": "int32"
            },
            "in": "query",
            "name": "mode",
            "description": "Which response schema to return. 0 - standard, returns response body of /result, 5 - concise, returns response body containing portions of the /details and /result, 10 - verbose, returns response body of /details."
          },
          {
            "schema": {
              "type": "string"
            },
            "in": "query",
            "name": "classId",
            "description": "The class ID as represented in your organization. Must be an exact match. "
          }
        ]
      }
    }
  },
  "components": {
    "schemas": {
      "ResultResponse": {
        "type": "object",
        "x-examples": {},
        "properties": {
          "LabProfileId": {
            "type": "integer",
            "description": "The unique identifier of the lab profile the lab is based on.",
            "format": "int32"
          },
          "Start": {
            "type": "integer",
            "description": "When the lab instance was started (in Unix epoch time).",
            "format": "int64"
          },
          "End": {
            "type": "integer",
            "description": "When the lab instance was ended (in Unix epoch time).",
            "format": "int64",
            "nullable": "true"
          },
          "LastActivity": {
            "type": "integer",
            "description": "The last time the student interacted with the lab (in Unix epoch time).",
            "format": "int64",
            "nullable": "true"
          },
          "UserId": {
            "type": "string",
            "description": "The user ID as represented in your organization.",
            "nullable": "true"
          },
          "ClassId": {
            "type": "string",
            "description": "The class ID as represented in your organization.",
            "nullable": "true"
          },
          "CompletionStatus": {
            "type": "integer",
            "description": "The status when the lab instance is completed.  Possible values are:  \n1 = Cancelled  \n2 = No Show  \n3 = Incomplete  \n4 = Complete  \n10 = Storage Provisioning Failed  \n20 = Lab Creation Failed  \n30 = Resume Failed  \n40 = Save Failed  \n50 = Submitted For Grading  \n60 = Grading In Progress  ",
            "format": "int32"
          },
          "TotalRunTimeSeconds": {
            "type": "integer",
            "description": "The total number of seconds the lab was running, whether or not the student was present.",
            "format": "int32"
          },
          "TaskCompletePercent": {
            "type": "integer",
            "description": "If the lab has integrated tasks, the percentage of tasks that the user has completed.",
            "format": "int32"
          },
          "IsExam": {
            "type": "boolean",
            "description": "Indicates whether the lab is scored."
          },
          "ExamPassed": {
            "type": "boolean",
            "description": "Indicates whether the user passed the lab. Will only be set if the lab has activities which have been scored.",
            "nullable": "true"
          },
          "ExamScore": {
            "type": "number",
            "description": "Indicates the lab score. Will only be set if the lab has activities which have been scored.",
            "format": "float",
            "nullable": "true"
          },
          "ExamMaxPossibleScore": {
            "type": "integer",
            "description": "Indicates the maximum possible score of the lab. Will only be set if the lab has activities which have been scored.",
            "format": "int32",
            "nullable": "true"
          },
          "ExamPassingScore": {
            "type": "integer",
            "description": "Indicates the minimum score required to pass the lab. Will only be set if the lab has activities which have been scored.",
            "format": "int32",
            "nullable": "true"
          },
          "IpAddress": {
            "type": "string",
            "description": "The user's IP address. This is only included if the IP address was provided when the lab was launched.",
            "nullable": "true"
          },
          "Country": {
            "type": "string",
            "description": "The user's country as determined by IP address geolocation. This is only included if the IP address was provided when the lab was launched.",
            "nullable": "true"
          },
          "Region": {
            "type": "string",
            "description": "The user's state/region as determined by IP address geolocation. This is only included if the IP address was provided when the lab was launched.",
            "nullable": "true"
          },
          "City": {
            "type": "string",
            "description": "The user's city as determined by IP address geolocation. This is only included if the IP address was provided when the lab was launched.",
            "nullable": "true"
          },
          "Latitude": {
            "type": "number",
            "description": "The user's latitude as determined by IP address geolocation. This is only included if the IP address was provided when the lab was launched.",
            "format": "float",
            "nullable": "true"
          },
          "Longitude": {
            "type": "number",
            "description": "The user's longitude as determined by IP address geolocation. This is only included if the IP address was provided when the lab was launched.",
            "format": "float",
            "nullable": "true"
          },
          "LabHostId": {
            "type": "integer",
            "description": "The ID of the lab host server that the lab instance is housed on.",
            "format": "int32",
            "nullable": "true"
          },
          "DatacenterId": {
            "type": "integer",
            "description": "The ID of the datacenter that the lab instance is located in.",
            "format": "int32",
            "nullable": "true"
          },
          "DeliveryRegionId": {
            "type": "integer",
            "description": "When specified, Skillable will attempt to launch the lab in the specified delivery region if a suitable host in that region is available and all required storage is available in that region. Delivery regions can be found using the **DeliveryRegions** command or **Catalog** command. Using the ipAddress parameter will result in a more reliable geo-location of the lab for the end user.",
            "format": "int32",
            "nullable": "true"
          },
          "Status": {
            "type": "integer",
            "description": "Indicates the status of the API request.  \n0 = Error  \n1 = Success  ",
            "format": "int32"
          },
          "Error": {
            "type": "string",
            "description": "In the event of an error, this will contain a detailed error message.",
            "nullable": "true"
          }
        }
      },
      "DetailsResponse": {
        "type": "object",
        "x-examples": {},
        "properties": {
          "Id": {
            "type": "integer",
            "description": "The ID of the lab instance.",
            "format": "int64"
          },
          "LabProfileId": {
            "type": "integer",
            "description": "The ID of the lab profile.",
            "format": "int32"
          },
          "LabProfileName": {
            "type": "string",
            "description": "The name of the lab profile."
          },
          "Products": {
            "type": "array",
            "x-stoplight": {
              "id": "bkm5i1qkr60ur"
            },
            "description": "The list of products assigned to the lab profile and their basic details.",
            "items": {
              "x-stoplight": {
                "id": "2wr8bhppl828i"
              },
              "type": "object",
              "properties": {
                "Id": {
                  "type": "integer",
                  "x-stoplight": {
                    "id": "wcpq8gzucpwhf"
                  },
                  "example": "48",
                  "description": "The unique identifier of the product."
                },
                "Name": {
                  "type": "string",
                  "x-stoplight": {
                    "id": "s7hh1lv151xf5"
                  },
                  "example": "Database",
                  "description": "The name of the product."
                }
              }
            }
          },
          "ApiConsumerName": {
            "type": "string",
            "x-stoplight": {
              "id": "pqb1q3f2zbd1z"
            }
          },
          "SeriesId": {
            "type": "integer",
            "description": "The ID of the lab series.",
            "format": "int32",
            "nullable": "true"
          },
          "UserId": {
            "type": "string",
            "description": "The ID you use to identify the user in your external system."
          },
          "SeriesName": {
            "type": "string",
            "description": "The name of the lab series.",
            "nullable": "true"
          },
          "UserFirstName": {
            "type": "string",
            "description": "The user's first name."
          },
          "UserLastName": {
            "type": "string",
            "description": "The user's last name."
          },
          "UserEmail": {
            "description": "The user's email address.",
            "type": "string",
            "x-stoplight": {
              "id": "qov42uvxpcdqz"
            },
            "nullable": "true"
          },
          "ClassId": {
            "description": "The ID you use to identify the associated class in your external system.",
            "type": "string",
            "nullable": "true"
          },
          "ClassName": {
            "description": "The name of the class the lab instance is associated with.",
            "type": "string",
            "nullable": "true"
          },
          "PreinstanceStartTime": {
            "type": "integer",
            "description": "When the lab was pre-instanced, if pre-instancing occurred (in Unix epoch time).",
            "format": "int64",
            "x-stoplight": {
              "id": "jt1a5kl9l4hdv"
            }
          },
          "Start": {
            "type": "integer",
            "description": "When the lab was started (in Unix epoch time).",
            "format": "int64"
          },
          "StartTime": {
            "type": "string",
            "description": "When the lab was started (in Unix epoch time)."
          },
          "Expires": {
            "type": "integer",
            "description": "When the lab expires (in Unix epoch time).",
            "format": "int64"
          },
          "ExpiresTime": {
            "type": "string",
            "description": "When the lab expires (in Unix epoch time)."
          },
          "End": {
            "type": "integer",
            "description": "When the lab ended (in Unix epoch time).",
            "format": "int64",
            "nullable": "true"
          },
          "EndTime": {
            "type": "string",
            "description": "When the lab ended (in Unix epoch time).",
            "nullable": "true"
          },
          "LastActivity": {
            "type": "integer",
            "description": "When student activity was last detected (in Unix epoch time).",
            "format": "int64",
            "nullable": "true"
          },
          "LastActivityTime": {
            "type": "string",
            "description": "When student activity was last detected (in Unix epoch time).",
            "nullable": "true"
          },
          "LastSave": {
            "type": "integer",
            "description": "When the lab was last saved (in Unix epoch time).",
            "format": "int64",
            "nullable": "true"
          },
          "LastSaveTime": {
            "type": "string",
            "description": "When the lab was last saved (in Unix epoch time).",
            "nullable": "true"
          },
          "SaveExpires": {
            "type": "integer",
            "description": "If the lab instance is saved, when the saved data will expire and be deleted (in Unix epoch time).",
            "format": "int64",
            "nullable": "true"
          },
          "SaveExpiresTime": {
            "type": "string",
            "description": "If the lab instance is saved, when the saved data will expire and be deleted (in Unix epoch time).",
            "nullable": "true"
          },
          "State": {
            "type": "string",
            "description": "The state of the lab instance. Possible values:  \nOff  \nProvisioning Storage  \nBuilding  \nBuilding (Displayable)  \nStarting  \nRunning  \nSaving  \nSaved  \nResuming  \nCreating Snapshot  \nApplying Snapshot  \nUpdating Lab Profile  \nTearing Down  \nCloning  \nCreating As Clone  \nMoving (Running)  \nMoving (Saved)  \nCreating New Lab Profile  \nScoring  \nScheduled"
          },
          "CompletionStatus": {
            "type": "string",
            "description": "The student's completion status. Possible values:  \nScheduled  \nCancelled  \nNot Started  \nIncomplete  \nComplete  \nStorage Provisioning Failed  \nLab Creation Failed  \nResume Failed  \nSave Failed  \nSubmitted For Grading  \nGrading In Progress"
          },
          "PoolMemberName": {
            "description": "If the lab contains a virtual machine pool, the name of the pool member that was used.",
            "type": "string",
            "nullable": "true"
          },
          "LabHostId": {
            "type": "integer",
            "description": "The ID of the lab host machine.",
            "format": "int32"
          },
          "LabHostName": {
            "type": "string",
            "description": "The name of the lab host machine."
          },
          "DatacenterId": {
            "type": "integer",
            "description": "The ID of the datacenter where the lab is located.",
            "format": "int32"
          },
          "DatacenterName": {
            "type": "string",
            "description": "The name of the datacenter where the lab is located."
          },
          "DeliveryRegionId": {
            "type": "integer",
            "description": "When specified, Skillable will attempt to launch the lab in the specified delivery region if a suitable host in that region is available and all required storage is available in that region. Delivery regions can be found using the **DeliveryRegions** command or **Catalog** command. Using the ipAddress parameter will result in a more reliable geo-location of the lab for the end user.",
            "format": "int32"
          },
          "DeliveryRegionName": {
            "type": "string",
            "description": "The name of the delivery region where the lab is located."
          },
          "PlatformId": {
            "type": "integer",
            "description": "The platform the lab has hosted on. Possible values:  \n2 = Hyper-V  \n3 = ESX  \n20 = Docker  \n-1 = None",
            "format": "int32"
          },
          "LastSaveTriggerType": {
            "description": "If the lab is currently saved, what triggered the save operation. Possible values:  \nUnknown  \nBy Student  \nBy Administrator  \nAutomatic  \nFrom API Consumer",
            "type": "string",
            "nullable": "true"
          },
          "TimeInSession": {
            "type": "integer",
            "description": "The total number of seconds the user spent in the lab.",
            "format": "int32"
          },
          "TotalRunTime": {
            "type": "integer",
            "description": "The total number of seconds the lab was running, whether or not the student was present.",
            "format": "int32"
          },
          "TimeRemaining": {
            "type": "integer",
            "description": "The total number of seconds remaining before the lab expires.",
            "format": "int32"
          },
          "InstructorId": {
            "type": "string",
            "x-stoplight": {
              "id": "t3mg7xh023gcy"
            },
            "description": "The unique ID of the instructor for the associated class.",
            "nullable": "true"
          },
          "InstructorName": {
            "description": "The name of the instructor for the associated class.",
            "type": "string",
            "nullable": "true"
          },
          "InstructorEmail": {
            "type": "string",
            "x-stoplight": {
              "id": "zh46r2jim6nyb"
            },
            "description": "The email address of the instructor for the associated class."
          },
          "StartupDuration": {
            "type": "integer",
            "description": "The number of seconds it took the lab to start.",
            "format": "int32",
            "nullable": "true"
          },
          "ErrorCount": {
            "type": "string",
            "x-stoplight": {
              "id": "ztppa90hwbgkx"
            },
            "description": "Count of errors for a given lab instance."
          },
          "Errors": {
            "type": "array",
            "description": "An array of all errors associated with the lab instance.",
            "items": {
              "type": "object"
            }
          },
          "Snapshots": {
            "type": "array",
            "description": "An array of snapshots created by the user within the lab. This contains an array of LabInstanceSnapshot objects.",
            "items": {
              "type": "object",
              "properties": {
                "Name": {
                  "type": "string",
                  "description": "The name that the student gave to the snapshot."
                },
                "Time": {
                  "type": "integer",
                  "description": "When the student created the snapshot (in Unix epoch time).",
                  "format": "int64"
                }
              }
            }
          },
          "Sessions": {
            "type": "array",
            "description": "An array of session times the student spent in the lab. This contains an array of LabInstanceSnapshot objects.",
            "items": {
              "type": "object",
              "properties": {
                "Start": {
                  "type": "integer",
                  "format": "int64",
                  "description": "When the session started (in Unix epoch time)."
                },
                "StartTime": {
                  "type": "string"
                },
                "End": {
                  "type": "integer",
                  "description": "When the session ended (in Unix epoch time).",
                  "nullable": "true"
                },
                "EndTime": {
                  "type": "string"
                }
              }
            }
          },
          "Notes": {
            "type": "array",
            "description": "Array of notes applicable to the lab instance.",
            "items": {
              "type": "object",
              "properties": {
                "Time": {
                  "type": "integer"
                },
                "TimeValue": {
                  "type": "string"
                },
                "Title": {
                  "type": "string"
                },
                "Text": {
                  "type": "string"
                }
              }
            }
          },
          "HasContent": {
            "type": "boolean",
            "description": "Indicates whether the lab has content, or simply houses virtual machines."
          },
          "Task": {
            "description": "If the lab has content (HasContent=true), indicates the name of the task the student is working on.",
            "type": "string",
            "nullable": "true"
          },
          "Exercise": {
            "description": "If the lab has content (HasContent=true), indicates the name of the exercise the student is working on.",
            "type": "string",
            "nullable": "true"
          },
          "NumTasks": {
            "type": "integer",
            "description": "If the lab has content (HasContent=true), indicates the total number of tasks in the lab.",
            "format": "int32"
          },
          "NumCompletedTasks": {
            "type": "integer",
            "description": "If the lab has content (HasContent=true), indicates the number of tasks the student has completed.",
            "format": "int32"
          },
          "TaskCompletePercent": {
            "type": "integer",
            "description": "If the lab has content (HasContent=true), indicates the percentage of tasks that the student has completed.",
            "format": "int32"
          },
          "MonitorUrl": {
            "description": "This response property is deprecated. Unless explicitly allowed by Skillable, this field will always be null.  \nTo obtain an access URL, use the **LabMonitorUrl** command.",
            "type": "string",
            "nullable": "true"
          },
          "DetailsUrl": {
            "type": "string",
            "description": "The URL at which the lab instance details can be reviewed (required authentication to view)."
          },
          "RemoteController": {
            "type": "string",
            "description": "The name of the remote controller used by the user."
          },
          "Tag": {
            "type": "string",
            "description": "Lab instance tag data.",
            "nullable": "true"
          },
          "BrowserUserAgent": {
            "type": "string",
            "description": "The browser user agent used by the user.",
            "nullable": "true"
          },
          "LastLatency": {
            "type": "integer",
            "description": "The last known latency value as measured between the client and the lab's datacenter.",
            "format": "int32",
            "nullable": "true"
          },
          "ExamPassed": {
            "type": "boolean",
            "description": "Indicates whether the user passed the lab. Will only be set if the lab has activities which have been scored.",
            "nullable": "true"
          },
          "ExamScore": {
            "type": "number",
            "description": "Indicates the lab score. Will only be set if the lab has activities which have been scored.",
            "format": "float",
            "nullable": "true"
          },
          "ExamMaxPossibleScore": {
            "type": "integer",
            "description": "Indicates the maximum possible score of the lab. Will only be set if the lab has activities which have been scored.",
            "format": "int32",
            "nullable": "true"
          },
          "ExamPassingScore": {
            "type": "integer",
            "description": "Indicates the minimum score required to pass the lab. Will only be set if the lab has activities which have been scored.",
            "format": "int32",
            "nullable": "true"
          },
          "ExamScoredById": {
            "type": "integer",
            "description": "The ID of the user that manually scored the lab. Will only be set if the lab has activities which have been scored manually. Automatically scored labs will not include a value for this property.",
            "format": "int64",
            "nullable": "true"
          },
          "ExamScoredByName": {
            "description": "The name of the user that manually scored the lab. Will only be set if the lab has activities which have been scored manually. Automatically scored labs will not include a value for this property.",
            "type": "string",
            "nullable": "true"
          },
          "ExamDetails": {
            "description": "Legacy Field from previous scoring engine.",
            "type": "string",
            "nullable": "true"
          },
          "ExamScoredDate": {
            "type": "integer",
            "description": "The date the lab was scored (in Unix epoch time).",
            "format": "int64",
            "nullable": "true"
          },
          "ExamScoredTime": {
            "type": "string",
            "description": "When the lab was scored (in Unix epoch time). Will only be set if the lab has activities which have been scored.",
            "nullable": "true"
          },
          "IsExam": {
            "type": "boolean",
            "description": "Indicates whether the lab is scored."
          },
          "IpAddress": {
            "type": "string",
            "description": "The user's IP address. This is only included if the IP address was provided when the lab was launched.",
            "nullable": "true"
          },
          "Country": {
            "type": "string",
            "description": "The user's country as determined by IP address geolocation. This is only included if the IP address was provided when the lab was launched.",
            "nullable": "true"
          },
          "Region": {
            "type": "string",
            "description": "The user's state/region as determined by IP address geolocation. This is only included if the IP address was provided when the lab was launched.",
            "nullable": "true"
          },
          "City": {
            "type": "string",
            "description": "The user's city as determined by IP address geolocation. This is only included if the IP address was provided when the lab was launched.",
            "nullable": "true"
          },
          "Latitude": {
            "type": "number",
            "description": "The user's latitude as determined by IP address geolocation. This is only included if the IP address was provided when the lab was launched.",
            "format": "float",
            "nullable": "true"
          },
          "Longitude": {
            "type": "number",
            "description": "The user's longitude as determined by IP address geolocation. This is only included if the IP address was provided when the lab was launched.",
            "format": "float",
            "nullable": "true"
          },
          "PublicIpAddresses": {
            "type": "array",
            "description": "An array of public IP address information objects. This contains an array of IpAddressInfo objects.",
            "items": {
              "type": "object",
              "properties": {
                "IpAddress": {
                  "type": "string",
                  "description": "An IP address."
                },
                "MacAddress": {
                  "type": "string",
                  "description": "The MAC address of the NIC that the IP address was assigned to."
                },
                "MachineInstanceName": {
                  "type": "string",
                  "description": "The name of the virtual machine instance that the IP address was assigned to."
                }
              }
            }
          },
          "CloudCredentials": {
            "type": "array",
            "description": "An array of credentials assigned to the lab instance. This contains an array of CloudCredential objects.",
            "items": {
              "type": "object",
              "properties": {
                "PropertiesJson": {
                  "type": "string",
                  "description": "Json serialized properties for the credentials, as defined in the cloud credential pool."
                },
                "Expires": {
                  "type": "integer",
                  "description": "When the credentials expire (in Unix epoch time).",
                  "format": "int64"
                },
                "DisplayName": {
                  "type": "string",
                  "description": "Friendly credential name displayed in the lab user interface."
                },
                "Message": {
                  "type": "string",
                  "nullable": "true"
                }
              }
            }
          },
          "CloudPortalCredentials": {
            "type": "array",
            "description": "An array of credentials assigned to the lab instance. This contains an array of CloudPortalCredential objects.",
            "items": {
              "type": "object",
              "properties": {
                "CloudPlatform": {
                  "type": "integer",
                  "format": "int32",
                  "description": "The ID of the cloud platform to which the credentials belong.  \n10 = Azure  \n11 = AWS"
                },
                "PropertiesJson": {
                  "type": "string",
                  "description": "Json serialized properties for the credentials."
                }
              }
            }
          },
          "VirtualMachineCredentials": {
            "type": "array",
            "description": "An array of credentials used to access the virtual machines. This contains an array of VirtualMachineCredential objects.",
            "items": {
              "type": "object",
              "properties": {
                "Id": {
                  "type": "integer",
                  "description": "ID of the virtual machine.",
                  "format": "int32"
                },
                "Name": {
                  "type": "string",
                  "description": "Name of the virtual machine."
                },
                "Username": {
                  "type": "string",
                  "description": "Username used to accces the virtual machine."
                },
                "Password": {
                  "type": "string",
                  "description": "Password used to access the virtual machine."
                }
              }
            }
          },
          "CloudPlatformId": {
            "type": "integer",
            "description": "The ID of the cloud platform. Possible values:  \n10 = Azure  \n11 = AWS",
            "format": "int32",
            "nullable": "true"
          },
          "ClientUrl": {
            "description": "This response property is deprecated. Unless explicitly allowed by Skillable, this field will always be null.  \nTo obtain an access URL, use the **LabAccessUrl** command.",
            "type": "string",
            "nullable": "true"
          },
          "ActivityResults": {
            "type": "array",
            "description": "An array of results for activities displayed in the lab instance. This contains an array of ActivityResult objects.",
            "items": {
              "type": "object",
              "properties": {
                "ActivityId": {
                  "type": "integer",
                  "description": "ID of the Activity.",
                  "format": "int32"
                },
                "ActivityName": {
                  "type": "string",
                  "description": "Name of the Activity."
                },
                "Scored": {
                  "type": "boolean",
                  "description": "Whether the activity is scored."
                },
                "Score": {
                  "type": "number",
                  "description": "The Score received by the student.",
                  "format": "float"
                },
                "Passed": {
                  "type": "boolean",
                  "description": "Whether the student received a passing score on the activity."
                },
                "ActivityType": {
                  "type": "integer",
                  "description": "0 = Multiple choice, single answer  \n10 = Multiple choice, multiple answer  \n20 = Short answer, exact match  \n30 = Short answer, regex match  \n40 = Automated Activity  ",
                  "format": "int32"
                },
                "TextResult": {
                  "type": "string",
                  "description": "The answer given by a student for Short Answer type questions.",
                  "nullable": "true"
                },
                "UiResponse": {
                  "type": "string",
                  "description": "The response given to the student if specified in the question Answer Feedback.",
                  "nullable": "true"
                },
                "AnswerResults": {
                  "type": "array",
                  "description": "A collection of the answers available in single-answer activities.",
                  "items": {
                    "type": "object",
                    "properties": {
                      "AnswerId": {
                        "type": "integer",
                        "format": "int32"
                      },
                      "AnswerText": {
                        "type": "string"
                      },
                      "Correct": {
                        "type": "boolean"
                      }
                    }
                  }
                },
                "ScriptResults": {
                  "type": "array",
                  "description": "A collection of the results of the an automated activity. Includes Script ID, Score, Passing Status, UiResponse, ScriptResponse, PlatformError, and ScriptError.",
                  "items": {
                    "type": "object"
                  }
                },
                "DisplayScriptsAsTaskList": {
                  "type": "boolean",
                  "description": "Whether automated activities are scored as a TaskList or individually."
                },
                "AnswerTexts": {
                  "type": "array",
                  "description": "A collection of the answers available in multi- answer activities.",
                  "items": {
                    "type": "object",
                    "properties": {
                      "Correct": {
                        "type": "boolean"
                      },
                      "AnswerId": {
                        "type": "integer",
                        "format": "int32"
                      },
                      "Text": {
                        "type": "string"
                      },
                      "Chosen": {
                        "type": "boolean"
                      }
                    }
                  }
                },
                "ScriptTexts": {
                  "type": "array",
                  "description": "The Activity ID and Text displayed in the Task List if Task List is enabled on the activity.",
                  "items": {
                    "type": "object"
                  }
                },
                "ShowResultsInReports": {
                  "type": "boolean",
                  "description": "Whether results of the script are shown on the lab instance."
                },
                "Skills": {
                  "type": "array",
                  "description": "The list of skills assigned to the lab activity and their basic details.",
                  "items": {
                    "type": "object",
                    "x-stoplight": {
                      "id": "tw3o9xfbb9uqw"
                    },
                    "properties": {
                      "Id": {
                        "type": "integer",
                        "x-stoplight": {
                          "id": "catx7lwp675c2"
                        },
                        "description": "The unique identifier of the skill."
                      },
                      "ExternalId": {
                        "type": "string",
                        "x-stoplight": {
                          "id": "1dw7cr9zq6n4j"
                        },
                        "description": "The optional external unique idf",
                        "nullable": "true"
                      },
                      "Name": {
                        "type": "string",
                        "x-stoplight": {
                          "id": "wwdz0ww5ed8dt"
                        },
                        "description": "The name of the skill."
                      },
                      "FrameworkId": {
                        "type": "integer",
                        "x-stoplight": {
                          "id": "zxaqmzr9hb5f5"
                        },
                        "description": "The unique identifier of the framework for this skill."
                      },
                      "FrameworkName": {
                        "type": "string",
                        "x-stoplight": {
                          "id": "5rrgxdmovdfzl"
                        },
                        "description": "The name of the framework for this skill."
                      }
                    }
                  }
                }
              }
            }
          },
          "ActivityGroupResults": {
            "type": "array",
            "description": "An array of results for activities displayed in the lab instance Activity Group. This contains an array of ActivityResult objects.",
            "items": {
              "type": "object",
              "properties": {
                "Id": {
                  "type": "integer",
                  "format": "int32",
                  "description": "ID of the Activity Group."
                },
                "Name": {
                  "type": "string",
                  "description": "Name of the Activity Group."
                },
                "ScoreValueTotal": {
                  "type": "number",
                  "format": "float",
                  "description": "The maximum score for the Activity Group."
                },
                "AggregateScore": {
                  "type": "number",
                  "format": "float",
                  "description": "The resultant score the of the Activity Group."
                },
                "ActivityResults": {
                  "type": "array",
                  "description": "An array of results for activities displayed in the lab instance Activity Group. This contains an array of ActivityResult objects.",
                  "items": {
                    "type": "object",
                    "properties": {
                      "ActivityId": {
                        "type": "integer",
                        "format": "int32",
                        "description": "ID of the Activity."
                      },
                      "ActivityName": {
                        "type": "string",
                        "description": "Name of the Activity."
                      },
                      "Scored": {
                        "type": "boolean",
                        "description": "Whether the activity is scored."
                      },
                      "Score": {
                        "type": "integer",
                        "description": "The Score received by the student."
                      },
                      "Passed": {
                        "type": "boolean",
                        "description": "Whether the student received a passing score on the activity."
                      },
                      "ActivityType": {
                        "type": "integer",
                        "description": "0 = Multiple choice, single answer  \n10 = Multiple choice, multiple answer  \n20 = Short answer, exact match  \n30 = Short answer, regex match  \n40 = Automated Activity  "
                      },
                      "TextResult": {
                        "type": "string",
                        "description": "The answer given by a student for Short Answer type questions."
                      },
                      "UiResponse": {
                        "type": "string",
                        "description": "The response given to the student if specified in the question Answer Feedback."
                      },
                      "AnswerResults": {
                        "type": "array",
                        "description": "A collection of the answers available in single-answer activities.",
                        "items": {
                          "type": "object"
                        }
                      },
                      "ScriptResults": {
                        "type": "array",
                        "description": "A collection of the results of the an automated activity. Includes Script ID, Score, Passing Status, UiResponse, ScriptResponse, PlatformError, and ScriptError.",
                        "items": {
                          "type": "object"
                        }
                      },
                      "DisplayScriptsAsTaskList": {
                        "type": "boolean",
                        "description": "Whether automated activities are scored as a TaskList or individually."
                      },
                      "AnswerTexts": {
                        "type": "array",
                        "description": "A collection of the answers available in multi- answer activities.",
                        "items": {
                          "type": "object",
                          "properties": {
                            "": {
                              "type": "string"
                            }
                          }
                        }
                      },
                      "ScriptTexts": {
                        "type": "array",
                        "description": "The Activity ID and Text displayed in the Task List if Task List is enabled on the activity.",
                        "items": {
                          "type": "object"
                        }
                      },
                      "ShowResultsInReports": {
                        "type": "boolean",
                        "description": "Whether results of the script are shown on the lab instance."
                      },
                      "Skills": {
                        "type": "array",
                        "description": "The list of skills assigned to the lab activity and their basic details.",
                        "items": {
                          "type": "object",
                          "x-stoplight": {
                            "id": "smt3iskg6udmq"
                          },
                          "properties": {
                            "Id": {
                              "type": "integer",
                              "x-stoplight": {
                                "id": "f23m4pglbwax5"
                              },
                              "format": "int32",
                              "description": "The unique identifier of the skill."
                            },
                            "ExternalId": {
                              "type": "string",
                              "x-stoplight": {
                                "id": "rp18u3c4rmuu7"
                              },
                              "description": "The optional external unique identifier of the skill.",
                              "nullable": "true"
                            },
                            "Name": {
                              "type": "string",
                              "x-stoplight": {
                                "id": "l4iwf8scj45cf"
                              },
                              "description": "The name of the skill."
                            },
                            "FrameworkId": {
                              "type": "integer",
                              "x-stoplight": {
                                "id": "kja02q4qxnmic"
                              },
                              "description": "The unique identifier of the framework for this skill."
                            },
                            "FrameworkName": {
                              "type": "string",
                              "x-stoplight": {
                                "id": "1gl6wd3eszn87"
                              },
                              "description": "The name of the framework for this skill."
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          "EstimatedReadySeconds": {
            "type": "integer",
            "description": "An estimated number of seconds before the lab is ready.",
            "format": "int32",
            "nullable": "true"
          },
          "InstructionsId": {
            "type": "string",
            "description": "The ID of the Instructions used",
            "nullable": "true"
          },
          "Lang": {
            "type": "string",
            "description": "The lanuage code of the instruction set.\n\nen = English  \nes = Spanish  \nfr = French  \nde = German  \npt = Portuguese  \nja = Japanese  \nzh-hans = Simplified Chinese  \nzh-hant = Traditional Chinese  \nko = Korean  ",
            "nullable": "true"
          },
          "Skills": {
            "type": "array",
            "description": "The list of skills assigned to the lab profile and their basic details.",
            "items": {
              "type": "object",
              "x-stoplight": {
                "id": "jhkn2lvirpmlc"
              },
              "properties": {
                "Id": {
                  "type": "integer",
                  "description": "The unique identifier of the skill."
                },
                "ExternalId": {
                  "type": "string",
                  "description": "The optional external identifier of the skill.",
                  "x-stoplight": {
                    "id": "92n99z40okupz"
                  },
                  "nullable": "true"
                },
                "Name": {
                  "type": "string",
                  "description": "The name of the skill.",
                  "x-stoplight": {
                    "id": "h5so2p95worpy"
                  }
                },
                "FrameworkId": {
                  "type": "integer",
                  "description": "The unique identifier of the framework for this skill.",
                  "x-stoplight": {
                    "id": "6o4t6ti2lkgq9"
                  }
                },
                "FrameworkName": {
                  "type": "string",
                  "description": "The name of the framework for this skill.",
                  "x-stoplight": {
                    "id": "jmbwbikfqhb32"
                  }
                }
              }
            }
          },
          "Error": {
            "type": "string",
            "description": "In the event of an error, this will contain a detailed error message.",
            "nullable": "true"
          },
          "Status": {
            "type": "integer",
            "description": "Indicates the status of the API request.  \n0 = Error  \n1 = Success  ",
            "format": "int32"
          }
        }
      },
      "ConciseResponse": {
        "type": "object",
        "x-examples": {},
        "properties": {
          "Results": {
            "type": "array",
            "items": {
              "type": "object",
              "properties": {
                "Id": {
                  "type": "integer"
                },
                "LabProfileId": {
                  "type": "integer"
                },
                "LabProfileName": {
                  "type": "string"
                },
                "Products": {
                  "type": "array",
                  "items": {
                    "type": "object",
                    "properties": {
                      "Id": {
                        "type": "integer"
                      },
                      "Name": {
                        "type": "string"
                      }
                    }
                  }
                },
                "SeriesId": {
                  "type": "integer"
                },
                "SeriesName": {
                  "type": "string"
                },
                "UserId": {
                  "type": "string"
                },
                "UserFirstName": {
                  "type": "string"
                },
                "UserLastName": {
                  "type": "string"
                },
                "UserEmail": {
                  "type": "string",
                  "nullable": "true"
                },
                "ClassId": {
                  "nullable": "true"
                },
                "ClassName": {
                  "nullable": "true"
                },
                "Start": {
                  "type": "integer"
                },
                "StartTime": {
                  "type": "string"
                },
                "Expires": {
                  "type": "integer"
                },
                "ExpiresTime": {
                  "type": "string"
                },
                "End": {
                  "type": "integer"
                },
                "EndTime": {
                  "type": "string"
                },
                "LastActivity": {
                  "type": "integer",
                  "nullable": "true"
                },
                "LastActivityTime": {
                  "type": "string",
                  "nullable": "true"
                },
                "LastSave": {
                  "type": "integer",
                  "nullable": "true"
                },
                "LastSaveTime": {
                  "type": "string",
                  "nullable": "true"
                },
                "SaveExpires": {
                  "nullable": "true"
                },
                "SaveExpiresTime": {
                  "nullable": "true"
                },
                "State": {
                  "type": "string"
                },
                "CompletionStatus": {
                  "type": "string"
                },
                "PoolMemberName": {
                  "nullable": "true"
                },
                "LabHostId": {
                  "type": "integer"
                },
                "LabHostName": {
                  "type": "string"
                },
                "DatacenterId": {
                  "type": "integer"
                },
                "DatacenterName": {
                  "type": "string"
                },
                "DeliveryRegionId": {
                  "type": "integer"
                },
                "DeliveryRegionName": {
                  "type": "string"
                },
                "PlatformId": {
                  "type": "integer"
                },
                "LastSaveTriggerType": {
                  "nullable": "true"
                },
                "TimeInSession": {
                  "type": "integer"
                },
                "TotalRunTime": {
                  "type": "integer"
                },
                "TimeRemaining": {
                  "type": "integer"
                },
                "InstructorId": {
                  "type": "string",
                  "x-stoplight": {
                    "id": "13tenoz6f1esp"
                  }
                },
                "InstructorName": {
                  "type": "string"
                },
                "InstructorEmail": {
                  "type": "string",
                  "x-stoplight": {
                    "id": "sw1nauuupii7e"
                  }
                },
                "StartupDuration": {
                  "type": "integer"
                },
                "ErrorCount": {
                  "type": "string",
                  "x-stoplight": {
                    "id": "2ipdkr6wmnfk6"
                  }
                },
                "Errors": {
                  "type": "array",
                  "items": {
                    "type": "object",
                    "properties": {
                      "Message": {
                        "type": "string"
                      },
                      "Time": {
                        "type": "integer"
                      },
                      "TimeValue": {
                        "type": "string"
                      }
                    }
                  }
                },
                "Snapshots": {
                  "type": "array",
                  "items": {
                    "type": "object"
                  }
                },
                "Sessions": {
                  "type": "array",
                  "items": {
                    "type": "object",
                    "properties": {
                      "Start": {
                        "type": "integer"
                      },
                      "StartTime": {
                        "type": "string"
                      },
                      "End": {
                        "type": "integer"
                      },
                      "EndTime": {
                        "type": "string"
                      }
                    }
                  }
                },
                "Notes": {
                  "type": "array",
                  "items": {
                    "type": "object",
                    "properties": {
                      "Time": {
                        "type": "integer"
                      },
                      "TimeValue": {
                        "type": "string"
                      },
                      "Title": {
                        "type": "string"
                      },
                      "Text": {
                        "type": "string"
                      }
                    }
                  }
                },
                "HasContent": {
                  "type": "boolean"
                },
                "Task": {
                  "nullable": "true"
                },
                "Exercise": {
                  "nullable": "true"
                },
                "NumTasks": {
                  "type": "integer"
                },
                "NumCompletedTasks": {
                  "type": "integer"
                },
                "TaskCompletePercent": {
                  "type": "integer"
                },
                "MonitorUrl": {
                  "nullable": "true"
                },
                "DetailsUrl": {
                  "type": "string"
                },
                "RemoteController": {
                  "type": "string"
                },
                "Tag": {
                  "nullable": "true"
                },
                "BrowserUserAgent": {
                  "type": "string",
                  "nullable": "true"
                },
                "LastLatency": {
                  "nullable": "true"
                },
                "ExamPassed": {
                  "type": "boolean"
                },
                "ExamScore": {
                  "type": "integer"
                },
                "ExamMaxPossibleScore": {
                  "type": "integer"
                },
                "ExamPassingScore": {
                  "type": "integer"
                },
                "ExamScoredById": {
                  "nullable": "true"
                },
                "ExamScoredByName": {
                  "nullable": "true"
                },
                "ExamDetails": {
                  "nullable": "true"
                },
                "ExamScoredDate": {
                  "type": "integer"
                },
                "ExamScoredTime": {
                  "type": "string"
                },
                "IsExam": {
                  "type": "boolean"
                },
                "IpAddress": {
                  "nullable": "true"
                },
                "Country": {
                  "nullable": "true"
                },
                "Region": {
                  "nullable": "true"
                },
                "City": {
                  "nullable": "true"
                },
                "Latitude": {
                  "nullable": "true"
                },
                "Longitude": {
                  "nullable": "true"
                },
                "PublicIpAddresses": {
                  "type": "array",
                  "items": {
                    "type": "object"
                  }
                },
                "CloudCredentials": {
                  "type": "array",
                  "items": {
                    "type": "object"
                  }
                },
                "CloudPortalCredentials": {
                  "type": "array",
                  "items": {
                    "type": "object"
                  }
                },
                "VirtualMachineCredentials": {
                  "type": "array",
                  "items": {
                    "type": "object",
                    "properties": {
                      "Id": {
                        "type": "integer"
                      },
                      "Name": {
                        "type": "string"
                      },
                      "Username": {
                        "type": "string"
                      },
                      "Password": {
                        "type": "string"
                      }
                    }
                  }
                },
                "CloudPlatformId": {
                  "nullable": "true"
                },
                "ClientUrl": {
                  "nullable": "true"
                },
                "ApiConsumerName": {
                  "type": "string",
                  "x-stoplight": {
                    "id": "i9zguz4t14wwo"
                  }
                },
                "PreinstanceStartTime": {
                  "nullable": "true"
                },
                "EstimatedReadySeconds": {
                  "nullable": "true"
                },
                "InstructionsSetId": {
                  "type": "string"
                },
                "Language": {
                  "type": "string"
                },
                "Skills": {
                  "type": "array",
                  "items": {
                    "type": "object",
                    "properties": {
                      "Id": {
                        "type": "integer"
                      },
                      "ExternalId": {
                        "type": "string"
                      },
                      "Name": {
                        "type": "string"
                      },
                      "FrameworkId": {
                        "type": "integer"
                      },
                      "FrameworkName": {
                        "type": "string"
                      }
                    }
                  }
                },
                "ExamScaledScore": {
                  "nullable": "true"
                },
                "ExamPassingRawScore": {
                  "nullable": "true"
                },
                "ExamMaxPossibleRawScore": {
                  "nullable": "true"
                },
                "ExamMinScaledScore": {
                  "nullable": "true"
                },
                "ExamMaxScaledScore": {
                  "nullable": "true"
                },
                "ExamCutoffScaledScore": {
                  "nullable": "true"
                }
              }
            }
          },
          "TotalResults": {
            "type": "integer"
          },
          "TotalPages": {
            "type": "integer"
          },
          "Error": {
            "nullable": "true"
          },
          "Status": {
            "type": "integer"
          }
        }
      }
    }
  }
}
````

